/**********************************************************************/
/*  Berekenen en tekenen van een Collatz-reeks met SVG.               */
/*  (c) 2024 Ben's Hobbyhoekje/Ben Boukes. Mag vrij worden gebruikt.  */
/**********************************************************************/

let stap, YY = [], startwaarde, maxUitvoer, maxWaarde = 0, maxStap;
const SVGbegin = '<svg width="500" height="500">', SVGend = '</svg>';
const SVGsorry = 'Sorry, uw browser heeft geen ondersteuning voor de &lt;svg&gt;-tag.';

function maakCollatz() {
  if (!initCollatz()) return;

  Collatz();
  maakUitvoer();
  maakGrafiek();
  document.getElementById('statusbalk').innerHTML = "Klaar";
}  // maakCollatz

function initCollatz() {
  YY.length = 0; stap = 0;
  startwaarde = document.getElementById('start').value;
  if (startwaarde == "") {
    document.getElementById('statusbalk').innerHTML = "<b>Er moet een startwaarde worden gegeven, n<sub>0</sub> &ge; 1.<b>";
    return false;
  }
//  startwaarde = parseInt(startwaarde);
  if (startwaarde < 1) {
    document.getElementById('statusbalk').innerHTML = "<b>Startwaarde n<sub>0</sub> moet &ge; 1 zijn.<b>";
    return false;
  }
  return true;
}  // initCollatz

//window.onload = initCollatz;

function Collatz() {
  let nn = startwaarde;

  document.getElementById('statusbalk').innerHTML = "Collatz-reeks berekenen";
  YY[0] = startwaarde;
  stap = 0;
  do {
    stap++;
    if ((nn % 2) == 0) YY[stap] = nn / 2;
    else YY[stap] = 3 * nn + 1;

    nn = YY[stap];
  } while (YY[stap] != 1);
}  // Collatz

function maakUitvoer() {
  let res = document.getElementById('Resultaat');
  let str;

  document.getElementById('statusbalk').innerHTML = "Uitvoer maken";
  maxUitvoer = YY.length;
  maxWaarde = 0;
  for (let i=0; i<(maxUitvoer-1); i++) {
    if (YY[i] > maxWaarde) {
      maxStap = i;
      maxWaarde = YY[i];
    }
  }

  str  = "Startwaarde = " + startwaarde + "\n";
  str += "Stoptijd    = " + maxUitvoer + "\n\n";
  str += "Hoogste waarde = " + maxWaarde + " in stap " + maxStap + "\n\n";
  str += "       stap,         waarde\n";
  str += "====================================\n";
  res.innerHTML = str;
  str = "";
  for (let i=0; i<maxUitvoer; i++) {
    str += "  " + padWaarde(i, 9) + ", " + padWaarde(YY[i], 22) + "\n";
    if ( (i % 10) == 0) {
      str += "------------------------------------\n";
      res.innerHTML += str;
      str = "";
    }
  }
  str += "====================================\n";
  res.innerHTML += str;
}  // maakUitvoer

function padWaarde(getal, lengte) {
  let str = getal.toString();

  while (str.length < lengte) {
    str = " " + str;
  }
  return str;
}  // padWaarde

function maakGrafiek() {
  document.getElementById('statusbalk').innerHTML = "Grafiek maken";
  maakAssen();
  maakCurve();
}  // maakGrafiek

function maakAssen() {
  let str = SVGbegin;
  str += '<line x1="25" y1="475" x2="25" y2="25" style="stroke:rgb(0,0,0);stroke-width:1" />';
  str += '<line x1="25" y1="475" x2="475" y2="475" style="stroke:rgb(0,0,0);stroke-width:1" />';
  str += SVGsorry + SVGend;
  document.getElementById('Grafiek').innerHTML = str;
}  // maakAssen

function maakCurve() {
  let str = SVGbegin, xxx, yyy;

  str += '<polyline points="';
  for (let i=0; i<maxUitvoer; i++) {
    xxx = i / maxUitvoer * 450 + 35;
    yyy = 475 - YY[i] / maxWaarde * 455;
    str += xxx + "," + yyy +" ";
  }
  str += ' "style="fill:none;stroke:rgb(0,0,128);stroke-width:2" />' + SVGend;
  document.getElementById('Grafiek1').innerHTML = str;
}  // maakACurve
